#include <sys/types.h>
#include <sys/shm.h>
#include <strings.h>
#include <errno.h>
#include <stdio.h>
#include <sys/wait.h>

int
main (void)
{
  key_t mykey;
  int shmid;
  char *testch = NULL;

  mykey = IPC_PRIVATE;

  printf ("creating private key... ");
  shmid = shmget (mykey, 65536, 0777);
  if (shmid != -1)
    {
      /* attach and read/write then from the forked process */
      int pid;
      int n;
      int status;
      printf ("id %x\n", shmid);
      printf ("attaching... ");
      testch = (char *) shmat (shmid, NULL, 0);
      if (testch == (char *) -1)
	{
	  printf ("error %d, %s\n", errno, strerror (errno));
	  /* todo: delete the shm area */
	  exit (1);
	}
      printf ("mapped to %x\n", testch);
 printf ("writing \'hello\' ...");
 snprintf (testch, 6, "hello");
 printf ("reading ... ");
 printf ("'%s'...", testch);
 if (strncmp (testch, "hello", 6))
   {
     printf ("failed, string mismatch\n");
     exit (1);
   }
 else
   printf ("ok\n");
      if ((pid = fork ()) == 0)
	{
	  printf ("forked...\n");
	  printf ("reading ... ");
	  printf ("'%s'...", testch);
	  if (strncmp (testch, "hello", 6))
	    {
	      printf ("failed, string mismatch\n");
	      exit (1);
	    }
	  else
	    printf ("ok\n");
	  exit (0);
	}
      if ((n = waitpid (pid, &status, 0)) != pid)
	{
	  printf ("wait pid failed, pid %d, n %d, errno %d\n", pid, n, errno);
	  exit (1);
	}
      else if (WIFEXITED (status))
	{
	  /* normal termination - pass child exist code onto our parent */
	  exit (WEXITSTATUS (status));
	}
	return 1;

    }
  else
    {
      printf ("error %d, %s\n", errno, strerror (errno));
      return 1;
    }

  return 0;
}
