#include <sys/types.h>
#include <sys/shm.h>
#include <strings.h>
#include <errno.h>
#include <stdio.h>

key_t ftok_check (char *name, int index)
{
  key_t temp;

  printf ("ftok (\'%s\',%d)...", name, index);
  temp = ftok (name, index);
  if (temp == (key_t) - 1)
    {
      printf ("error %d, %s\n", errno, strerror (errno));
      exit (1);
    }
  printf ("key value %0qx\n", temp);
  return temp;
}

int
main (void)
{
  key_t mykey;
  int shmid;
  char *testch = NULL;

  mykey = ftok_check ("shmat.o", 1);
  printf ("creating \'shmat.o:1\'... ");

  shmid = shmget (mykey, 65536, 0777 | IPC_CREAT);
  if (shmid != -1)
    {
      printf ("id %x\n", shmid);
      printf ("attaching... ");
      testch = (char *) shmat (shmid, NULL, 0);
      if (testch == (char *) -1)
	{
	  printf ("error %d, %s\n", errno, strerror (errno));
	  /* todo: delete the shm area */
	  return 1;
	}
      printf ("mapped to %x\n", testch);
      printf ("reading ... '%s'\n", testch);
#ifdef INTERACTIVE
      printf ("waiting for enter\n");
      getc (stdin);
#endif
      printf ("writing \'hello\' ...\n");
      snprintf (testch, 6, "hello");
      printf ("reading ...");
      printf ("'%s'\n", testch);
#ifdef INTERACTIVE
      printf ("waiting for enter\n");
      getc (stdin);
#endif
    }
  else
    {
      printf ("error %d, %s\n", errno, strerror (errno));
      return 1;
    }

  return 0;
}
