#include <sys/types.h>
#include <sys/shm.h>
#include <strings.h>
#include <errno.h>

/* Test shmctl IPC_RMID 
 */

key_t ftok_check (char *name, int index)
{
  key_t temp;

  printf ("ftok (\'%s\',%d)...", name, index);
  temp = ftok (name, index);
  if (temp == (key_t) - 1)
    {
      printf ("error %d, %s\n", errno, strerror (errno));
      exit (1);
    }
  printf ("key value %0qx\n", temp);
  return temp;
}


int
main (void)
{
  key_t mykey;
  int shmid, shmid1;
  struct shmid_ds shmds;
  mykey = ftok_check ("shmctl_rmid.o",1 );

  printf ("creating private key... ");
  shmid = shmget (mykey, 65536, 0777 | IPC_CREAT);
  if (shmid != -1)
      printf ("id %0x\n", shmid);
  else
    {
      printf ("failed\nerror %d, %s\n", errno, strerror (errno));
      return 1;
    }
  printf ("delete private key... ");
  if (shmctl(shmid, IPC_RMID, NULL))
    {
      printf ("failed\nerror %d, %s\n", errno, strerror (errno));
      return 1;
    }
  else if ((shmid1 = shmget (mykey, 65536, 0777)) != -1)
    {
      printf ("failed - the id is still in existence\n");
      return 1;
    }
  else
    printf("ok\n");

  return 0;
}
