#include <sys/types.h>
#include <sys/shm.h>
#include <strings.h>
#include <errno.h>

/* Test shmctl IPC_SET.
 * FIXME: low priority for now 
 * todo: reuse the previously stored to disk private shm id
 */

int
main (void)
{
  key_t mykey;
  int shmid, shmid1;
  struct shmid_ds shmds;
  mykey = IPC_PRIVATE;

  printf ("creating private key... ");
  shmid = shmget (mykey, 65536, 0777);
  if (shmid != -1)
      printf ("id %0x\n", shmid);
  else
    {
      printf ("failed\nerror %d, %s\n", errno, strerror (errno));
      return 1;
    }
  printf ("creating 2nd private key... ");
  shmid1 = shmget (mykey, 65536, 0777);
  if (shmid1 == shmid)
    {
      printf ("failed - duplicate id\n");
      return 1;
    }
  else if (shmid != -1)
      printf ("id %0x\n", shmid1);
  else
    {
      printf ("failed\nerror %d, %s\n", errno, strerror (errno));
      return 1;
    }
  printf ("Getting shmid_ds for shmid %0x...",shmid);
  if (shmctl (shmid, IPC_STAT, &shmds))
    {
      printf ("failed\nerror %d, %s\n", errno, strerror (errno));
      return 1;
    }
  else if (shmds.shm_segsz != 65536 ||
	shmds.shm_nattch != 0 /* also check perms */)
    {
      printf ("failed, returned data not consistent with our requested memory area\n");
      return 1;
    }
  else
    printf("ok\n");
    

  return 0;
}
