#include <sys/types.h>
#include <sys/shm.h>
#include <strings.h>
#include <errno.h>

key_t ftok_check (char *name, int index)
{
  key_t temp;

  printf ("ftok (\'%s\',%d)...", name, index);
  temp = ftok (name, index);
  if (temp == (key_t) - 1)
    {
      printf ("error %d, %s\n", errno, strerror (errno));
      exit (1);
    }
  printf ("key value %0qx\n", temp);
  return temp;
}

int
main (void)
{
  key_t mykey;
  int shmid, shmid1, shmid2;

  mykey = ftok_check ("shmget.o", 1);
  printf ("creating shmget.o:1..");

  shmid1 = shmget (mykey, 65536, 0777 | IPC_CREAT);
  if (shmid1 != -1)
    printf ("shm id %x\n", shmid1);
  else
    {
      printf ("failed\nerror %d, %s\n", errno, strerror (errno));
      return 1;
    }

  printf ("creating second shmget.o:1 (check for same shmid)..");

  shmid2 = shmget (mykey, 65536, 0777 | IPC_CREAT);
  if (shmid2 == shmid1)
    printf ("ok\n");
  else if (shmid2 != -1)
    {
      printf ("failed\nWrong shm id returned: %x\n", shmid2);
      return 1;
    }
  else
    {
      printf ("error %d, %s\n", errno, strerror (errno));
      return 1;
    }

  mykey = ftok_check ("shmget.o", 20);
  printf ("creating exclusive shmget.o:2\n");

  shmid = shmget (mykey, 65536, 0777 | IPC_CREAT | IPC_EXCL);
  if (shmid != -1)
    printf ("shm id %x\n", shmid);
  else
    {
      printf ("error %d, %s\n", errno, strerror (errno));
      return 1;
    }

  printf ("creating exclusive shmget.o:2 (should fail)\n");
  shmid = shmget (mykey, 65536, 0777 | IPC_CREAT | IPC_EXCL);
  if (shmid != -1 || (shmid == -1 && errno != EEXIST))
    {
      printf ("unexpected pass: shm id %x\n", shmid);
      return 1;
    }
  else
    printf ("error %d, %s\n", errno, strerror (errno));

  printf
    ("creating non-exclusive shmget.o:2 (should be the same as the prior id)\n");
  shmid = shmget (mykey, 65536, 0777 | IPC_CREAT);
  if (shmid != -1)
    printf ("shm id %x\n", shmid);
  else
    {
      printf ("error %d, %s\n", errno, strerror (errno));
      return 1;
    }

  return 0;
}
